package com.me.brickbuster.entity;

public class BrickShape {

	public static final int BOTTOM_LEFT = 0x1;
	public static final int MIDDLE_LEFT = 0x1 << 1;
	public static final int TOP_LEFT = 0x1 << 2;
	public static final int TOP_MIDDLE = 0x1 << 3;
	public static final int CENTER = 0x1 << 4;
	public static final int TOP_RIGHT = 0x1 << 5;
	public static final int MIDDLE_RIGHT = 0x1 << 6;
	public static final int BOTTOM_RIGHT = 0x1 << 7;
	public static final int BOTTOM_MIDDLE = 0x1 << 8;

	public enum Shape {

		RECTANGLE(BOTTOM_LEFT | TOP_LEFT | TOP_RIGHT | BOTTOM_RIGHT),
		DIAMOND(MIDDLE_LEFT | TOP_MIDDLE | MIDDLE_RIGHT | BOTTOM_MIDDLE),
		UP(BOTTOM_LEFT | TOP_MIDDLE | BOTTOM_RIGHT),
		HALF_UP(BOTTOM_LEFT | CENTER | BOTTOM_RIGHT),
		DOWN(TOP_LEFT | TOP_RIGHT | BOTTOM_MIDDLE),
		HALF_DOWN(TOP_LEFT | TOP_RIGHT | CENTER),
		LEFT(MIDDLE_LEFT | TOP_RIGHT | BOTTOM_RIGHT),
		HALF_LEFT(CENTER | TOP_RIGHT | BOTTOM_RIGHT),
		RIGHT(BOTTOM_LEFT | TOP_LEFT | MIDDLE_RIGHT),
		HALF_RIGHT(BOTTOM_LEFT | TOP_LEFT | CENTER),
		DOWN_RIGHT_TRIANGLE(BOTTOM_LEFT | TOP_RIGHT | BOTTOM_RIGHT),
		UP_RIGHT_TRIANGLE(TOP_LEFT | TOP_RIGHT | BOTTOM_RIGHT),
		UP_LEFT_TRIANGLE(BOTTOM_LEFT | TOP_LEFT | TOP_RIGHT),
		DOWN_LEFT_TRIANGLE(BOTTOM_LEFT | TOP_LEFT | BOTTOM_RIGHT),
		HALF_UPPER(MIDDLE_LEFT | TOP_LEFT | TOP_RIGHT | MIDDLE_RIGHT),
		HALF_LOWER(BOTTOM_LEFT | MIDDLE_LEFT | MIDDLE_RIGHT | BOTTOM_RIGHT),
		HALF_LEFT_SQUARE(BOTTOM_LEFT | TOP_LEFT | TOP_MIDDLE | BOTTOM_MIDDLE),
		HALF_RIGHT_SQUARE(BOTTOM_MIDDLE | TOP_MIDDLE | TOP_RIGHT | BOTTOM_RIGHT),
		LEFT_DOWN_RIGHT_TRIANGLE(BOTTOM_LEFT | TOP_MIDDLE | BOTTOM_MIDDLE),
		LEFT_UP_RIGHT_TRIANGLE(TOP_LEFT | TOP_MIDDLE | BOTTOM_MIDDLE),
		LEFT_UP_LEFT_TRIANGLE(BOTTOM_LEFT | TOP_LEFT | TOP_MIDDLE),
		LEFT_DOWN_LEFT_TRIANGLE(BOTTOM_LEFT | TOP_LEFT | BOTTOM_MIDDLE),
		RIGHT_DOWN_RIGHT_TRIANGLE(BOTTOM_MIDDLE | TOP_RIGHT | BOTTOM_RIGHT),
		RIGHT_UP_RIGHT_TRIANGLE(TOP_MIDDLE | TOP_RIGHT | BOTTOM_RIGHT),
		RIGHT_UP_LEFT_TRIANGLE(BOTTOM_MIDDLE | TOP_MIDDLE | TOP_RIGHT),
		RIGHT_DOWN_LEFT_TRIANGLE(BOTTOM_MIDDLE | TOP_MIDDLE | BOTTOM_RIGHT),
		;

		private int mask;

		Shape(int mask) {
			this.mask = mask;
		}

		public int getMask() {
			return mask;
		}
	}


}
